
;*******************************************************************************
;				RDA5807M_&_Nokia5110.asm
;	 FM-   RDA5807M  LCD- Nokia5110
;  ATMEGA8    .  8 .
; 		  :
;-*-    /     +F  -F.
;-*-   +   - ,      .
;-*-    +V  -V.
;-*-        0  15.
;-*-       .
;-*-  "-"   ,   .
;-*-        .
;-*-      .
;-*-      EEPROM.
;-*-       .
;-*-         
;-*-   .
;-*-    I2C.
;
;  :
; PB0 - .   -
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
; PB7 - .   -
;
; PC0 -  +V
; PC1 -  -V
; PC2 -  +S
; PC3 -  -S
; PC4(. 27) - (SDA) -   
; PC5(. 28) - (SCL) -   
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 

  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		;   LCD
	.equ ram_read_en = 0 	;: 0-   FLASH, 1-   
	.def time	=	r21		;  
	.def F_3H	=	r22		;.   
	.def F_3L	=	r23		;.   
	.def freq	=	r24		;   ( )
;-----------------------------------------------------------------------------
;	!        .
	
	.equ Nst   = 14			;  
;-----------------------------------------------------------------------------
	;  LCD  ATmega8
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
	
;===============================================================================
	.DSEG					;    SRAM ()
	.ORG 0x060				;   
	decnum: .BYTE 5			;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	;  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG					;    EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 
;=============================================================================
.CSEG		;  
.ORG 0 		; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	reti				; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00000110			;   RES  SE 
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;
		out PORTC,temp   			;  
		
			;  D
	 ;	ldi temp,0b00000000			;   D
	;	out DDRD,temp				;
	;	ldi temp,0					;
	;	out PORTD,temp				;   D  
		
			;  0
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;    T0 
		out TCNT0,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		ldi temp,0b00000001			; .    T0
		out TIMSK,temp				;
		
		sei                         ;  
		
;------------------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R20  0
		brne PC-1					;
	.ENDMACRO
;===================   ==================================
			; 
		sbi RES_port,RES			;   RES
		DELAY 1						;  32 
		cbi LCD_SCE_port,LCD_SCE	;.  LCD
		rcall Delay10us				; 10 
		
		;  LCD
		cbi RES_port,RES			;   LCD
		DELAY 1						;   32 
		sbi RES_port,RES			;   LCD
		;
		rcall Delay10us				; 10 
		
		sbi LCD_SCE_port,LCD_SCE	;.  LCD
		DELAY 1						;  32 
		rcall lcd_init				; LCD 
		rcall lcd_clr				; LCD
		;    LCD
		ldi temp,0x80				;     =0
		rcall lcd_XY				;
		ldi temp,0x40				;  1-  Y = 0
		rcall lcd_XY				;
		;    
		ldi ZL,low((Messg1)*2) 		;  
		ldi ZH,high((Messg1)*2)		; (   )
		rcall Str_LCD				; .  LCD
		
;------------------------------------------------------------------------------
		;  RDA5807
		rcall speed_clk				;    I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;     EEPROM
		;
		DELAY 20					; 656 
	;	ldi temp,0b11110010			;(02H) .,,, 
		ldi temp,0b11010010			;(02H) .,,, 
		mov r5,temp					; - 
		rcall Config_RDA5807		; RDA5807
		DELAY 20					; 656 
		
		ldi ZL,LOW((Messg3)*2)		;   
		ldi ZH,HIGH((Messg3)*2)		;  ". "
		
		;    LCD
		ldi temp,0x80				;     =0
		rcall lcd_XY				;
		ldi temp,5					;  6-  Y = 0
		rcall lcd_XY				;
		rcall Str_LCD				;  ". "  
		
		clr r2						;  
		clr r8						;
		clr r9						;
		clr freq					;  
		clr temp3					;  R19
		
;------------------------------------------------------------------
main: 			; 
		in temp,PINC				; 
		com temp					; 
		andi temp,0x0F				;  
		mov r1,temp					;   
		;   ()
		DELAY 1						; 32  
		cp r1,r2					;  
		breq main					;  -  
		
		;  , .  
		mov temp,r2					;   
		cpi temp,12					;   
		brne upr_vol				;
		rcall mode					;     
		rjmp main					;
		
upr_vol:sbrc temp,0					;   +F
		rcall vol_up				;    
		sbrc temp,1					;   -F
		rcall vol_dw				;    
		
		tst R8						;   
		brne avto					;    
		
		sbrc temp,2					;   +S
		rcall St_Up					;     
		sbrc temp,3					;   -S
		rcall St_Down				;     
		
		rjmp main					; , -  
		
avto:	sbrc temp,2					;   +S
		rcall freq_Up				;    
		sbrc temp,3					;   -S
		rcall freq_Down				;    
		
		rjmp main					; , -  
		;
;===========================================================================
mode:		;    /
		clr r2						;  
		tst R8						;   
		brne man					;
		inc R8						;   
		
		ldi ZL,LOW((Messg5)*2)		;  
		ldi ZH,HIGH((Messg5)*2)		; ""
		ldi temp,0x80				;     =0
		rcall lcd_XY				;
		ldi temp,5					;  6-  Y = 0
		rcall lcd_XY				;
		rcall Str_LCD				;   
		rjmp mod_end				;
		
man:	clr R8						;    
		ldi ZL,LOW((Messg2)*2)		;  
		ldi ZH,HIGH((Messg2)*2)		; " "
		ldi temp,0x80				;     =0
		rcall lcd_XY				;
		ldi temp,5					;  6-  Y = 0
		rcall lcd_XY				;
		rcall Str_LCD				;   
mod_end:clr temp					; temp    
 		ret
		
;===========================================================================
freq_Up:	;   "+"   
		clr r2						;  
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
		
	;	ldi temp,0b11110011			;(02H) .,,, 
		ldi temp,0b11010011			;(02H) .,,, 
		rjmp nastr					;  
		
;===========================================================================
freq_Down:		;   "-"   
		clr r2						;  
		dec freq					; 
	;	ldi temp,0b11110001			;(02H) .,,, 
		ldi temp,0b11010001			;(02H) .,,, 
		
nastr:	mov r5,temp					; - 
		rcall Set_Fq				; 
		rcall Mono					; ""
		
nov_m:	DELAY 15					;
		rcall Read_RDA5807			;   RDA5807
		lds r17,seek_fm				;  . 
		sbrs r17,6					;   , -
		rjmp nov_m					;  . 
		
		DELAY 10					;
		rcall Read_RDA5807			;   RDA5807
		lds freq,read_fm			;    
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		
		;ldi temp,0b11110010		;(02H) .,,, 
		ldi temp,0b11010010			;(02H) .,,, 
		mov r5,temp					; - 
		rcall Config_RDA5807		;    /
		
		clr temp					; temp    
		
 		ret
;===========================================================================
 St_Up:			;     FLASH
 		clr r2						;  
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;  
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
		
St_Down:	;     FLASH
		clr r2						;  
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		
	;	ldi temp,0b11110010			;(02H) .,,, 
		ldi temp,0b11010010			;(02H) .,,, 
		mov r5,temp					;
		rcall Config_RDA5807		;    /
		
		rcall Mono					; ""
		DELAY 10					;
		rcall Read_RDA5807			;   RDA5807
	;	DELAY 10					;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		
		clr temp					; temp    
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		inc YL						;
Rd_EEV:	sbic EECR,EEWE				;   
		rjmp Rd_EEV					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp,EEDR				;   . 
			andi temp,0x0F				;  
		sts volume,temp				;    
		
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		rcall Print					;   
Set_Fq:	in r25,SREG					;  . SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				; 
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10001101			;(02L): Fclk=32.768kHz, RDS_EN,
		rcall IIC_Send				; 			NEW_METHOD, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;
		
		rcall iic_stop 				; 
		rcall type_vol				;    LCD
		
		;   ,  YH:YL   
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
Wr_EEF:	sbic EECR,EEWE				;  
		rjmp Wr_EEF					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		;
		inc YL						;
		lds temp,volume				;    
Wr_EEV:	sbic EECR,EEWE				;  
		rjmp Wr_EEV					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		
		out SREG,r25			  	;  
		
		ret
; ========================================================================
		; 
vol_up:	clr r2				;  
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_pl			; ,  
		inc temp			; 
		sts volume,temp		;  
vol_pl:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 656 
		clr temp			; temp    
		ret
;-------------------------------------------------------------------------
		; 
vol_dw:	clr r2				;  
		lds temp,volume		;    
		cpi temp,0			;  
		breq vol_mi			; ,  
		dec temp			; 
		sts volume,temp		;  
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 656 
		clr temp			; temp    
		ret
		
; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;

		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		
		ret

;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		ldi temp,173				;  6-  128+(7*6)=170
		rcall lcd_XY				;
		ldi temp,0					;  1-  Y = 0
		rcall lcd_XY				;
			;   10- 
		clr R17						;
		lds temp,volume				;    
		andi temp,0x0F				;  
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		
		ret

;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		;    LCD
		ldi temp,128				;     =0
		rcall lcd_XY				;
		ldi temp,0					;  1-  Y = 0
		
		lds temp,level				;     
	;	lds temp,volume				;   
		andi temp,0x0F				;  
		mov R7,temp					; temp  R6
		
		cpi temp,12					;
		brmi PC+4					;
		ldi ZL,LOW((Messg10)*2)		;   
		ldi ZH,HIGH((Messg10)*2)	;  " 4"
		rjmp tp_lev					;    /
		
		mov temp,R7					;
		cpi temp,8					;
		brmi PC+4					;
		ldi ZL,LOW((Messg9)*2)		;   
		ldi ZH,HIGH((Messg9)*2)		;  " 3"
		rjmp tp_lev					;    /
		
		mov temp,R7					;
		cpi temp,4					;
		brmi PC+4					;
		ldi ZL,LOW((Messg8)*2)		;   
		ldi ZH,HIGH((Messg8)*2)		;  " 2"
		rjmp tp_lev					;    /
		
		mov temp,R7					;
		cpi temp,1					;
		brmi PC+4					;
		ldi ZL,LOW((Messg7)*2)		;   
		ldi ZH,HIGH((Messg7)*2)		;  " 1"
		rjmp tp_lev					;    /
		
		mov temp,R7					;
		tst temp					;
		brne PC+3					;
		ldi ZL,LOW((Messg6)*2)		;   
		ldi ZH,HIGH((Messg6)*2)		;  " 0"
		
tp_lev:	rcall Str_LCD				;   
		
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
t_1:	tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
;		       LCD 
;---------------------------------------------------------------------------
Print:		;    
		;    LCD
		ldi temp,0x80			;     =0
		rcall lcd_XY			;
		ldi temp,5				;  6-  Y = 0
		rcall lcd_XY			;
		rcall Str_LCD			;   
 Prnt_F:		;      
		;    LCD
		ldi temp,0x86			;   =6
		mov r6,temp				;  
		rcall lcd_XY			;
		ldi temp,2				;  3-  Y = 0
		rcall lcd_XY			;
		;    
		clr r18					;
		ldi r17,0x3				;    -
		ldi temp,0x66			; 870(10)  -> 366 (16)
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		ldi YL,LOW(decnum)		;.  X . .   
		clr YH					;
		ldi temp,3				; .    
		add YL,temp				;
		
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall Dig_x2			;  LCD 
		rjmp PC+2				
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		;  LCD 
		ldI temp,0x20			;   
		rcall lcd_put_char		;
		;   
		ldi temp,0xAA			; = 87+C+C+C = AA
		rcall lcd_XY			;
		ldi temp,0x03			;  4 
		rcall lcd_XY			;
	;	ldI temp,0x2C			; 
		ldI temp,127			; 
		rcall lcd_put_char		;  LCD 
		;     
		ldi temp,6				;    1 
		add r6,temp				;  
		ldi temp,0x02			;  3 
		rcall lcd_XY			;
		
		ld temp,-Y				; .  
		rcall Dig_x2			;   
		
		;    ""
		ldi temp,0xBD			; = 0xBD
		rcall lcd_XY			;
		ldi temp,0x03			;  4 
		rcall lcd_XY			;
		
		ldi ZL,LOW((Messg4)*2)	;   
		ldi ZH,HIGH((Messg4)*2)	;  ""
		rcall Str_LCD			;   
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	;push R30
	;	push R31
		;    LCD
		ldi temp,200				;  13-  128+(12*6)=200
		rcall lcd_XY				;
		ldi temp,0					;  1-  Y = 0
		rcall lcd_XY				;
		ldi temp,'M'				;
		rcall lcd_put_char			;  ""  LCD
		
		cbi PORTB,0					; 
	;	pop R31
	;	pop R30
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	;push R30
	;	push R31
		;    LCD
		ldi temp,200				;  13-  128+(12*6)=200
		rcall lcd_XY				;
		ldi temp,0					;  1-  Y = 0
		rcall lcd_XY				;
		
		ldi temp,'S'				;
		rcall lcd_put_char			;  "S"  LCD
		
		sbi PORTB,0					; 
	;	pop R31
	;	pop R30
		ret

;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;=========================================================================

;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
	;.include "I2C_soft_driver.asm"		;   I2C
 	.include "Nokia5110_driver.asm"		; LCD Nokia5110
 	.include "Font_6x8.asm" 			;  
;******************************************************************************
;===========================================================================
		;      

;  Messg1: .DB  '','',' ','8','7','-','1','0','8',' ','','','',' ', 0
  Messg1: .DB  '!',' ','"','"',' ',' ','/',' ',' ',' ',' ',' ',' ',' ', 0	; 0
  Messg2: .DB  ' ','','','','','','',' ','','','','','',' ', 0
  Messg3: .DB  '','','','','.','','','','','','','','','', 0
  Messg4: .DB  '','','',0, 0
  Messg5: .DB  ' ',' ','','','','','','','','','',' ',' ',' ', 0
  
  Messg6: .DB  '!',' ','"','"', 0	; 0
  Messg7: .DB  '!',' ','#','"', 0	; 1
  Messg8: .DB  '!',' ','$','"', 0	; 2
  Messg9: .DB  '!',' ','$','%', 0	; 3
  Messg10: .DB  '!',' ','$','&', 0	; 4

;-------------------------------------------------------------------------------
	freq_st:		;  FM-
 	.DB  41,' ',' ','','','','','','','','','',' ',' ',' ',0   	; 	    911  29
  	.DB  46,' ',' ',' ','','','','',' ','','',' ',' ',' ',' ',0 	   	; FM	    916	 2E
  	.DB 121,' ',' ',' ','','','','','','','',' ',' ',' ',' ',0   	;	    991	 79
  	.DB 132,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1002	 84
  	.DB 140,' ','','','','','',' ','','','','','','',' ',0   	;   1010	 8C
  	.DB 144,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0  		; FM	   1014	 90
  	.DB 157,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1027	 9D
  	.DB 162,' ','','','','','','',' ','','','','',' ',' ',0  		;    1032	 A2
  	.DB 166,' ',' ',' ','','','','','','','','',' ',' ',' ',0   	;	   1036  A6
  	.DB 177,' ',' ','','','','','','',' ','','',' ',' ',' ',0    	;DJ-FM		   1047  B1
  	.DB 182,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0   	;Kiss FM	   1052  B6
  	.DB 189,'','','','','','','',' ','','','','','',' ',0     	;  1059  BD
  	.DB 199,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0   	; FM		   1069  C7
	.DB 204,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0  		; FM		   1074  CC
		;
;=================================================================================

	.EXIT

